library delphi_phase5_plugin;

{$E .dll}

uses
    SysUtils,
    Classes,
    Forms,
    Windows,
    form in'form.pas'{formMain};

const
    cbVersion           =1; //Aus Kompatibilittsgrnden notwendig, NICHT ndern.

    cbComplete          =2; //Bedeutet, das der komplette Text im Editor ersetzt werden soll.
    cbSelection         =1; //Bedeutet, das nur der markierte Text im Editor ersetzt werden soll.
    cbCancel            =0; //Bedeutet, das die Aktionen des Plugins abgebrochen wurden und nichts im Editor gendert wird.

    //Die folgende Funktion ist die eigentliche Kernfunktion des Plugins,
    //und damit auch die wichtigste fr Pluginentwickler!
    //Hier kann beliebiger Code stehen, der entweder den kompletten
    //oder nur den markierten Text im Editor ersetzt.

    //Parameter die der Editor bergibt:
    //Text          :       Enthlt den kompletten Text aus dem Editor
    //                      Ist vom Typ: PChar

    //SelStart      :       Cursorposition im Editor, oder falls Text markiert
    //                      ist, die Startposition der Markierung.
    //                      Entspricht der Delphifunktion TMemo.SelStart
    //                      Ist vom Typ: Integer bzw. Int

    //SelLength     :       Lnge der Markierung.
    //                      Falls kein Text markiert ist diese Variable 0.
    //                      Entspricht der Delphifunktion TMemo.SelLength
    //                      Ist vom Typ: Integer bzw. Int

    //Der Rckgabewert der Funktion ist ein String vom Typ PChar.
    //Dieser Schritt wurde aus Grnden der Plugin-Kompatibilitt zu C++ etc.
    //gemacht.

function pluginStart(Text: PChar; SelStart: Integer; SelLength: Integer): PChar; export; stdcall;
var
    formMain            : TformMain;
begin
    if ((Application<>nil)and(Application.Handle>0)) then
        formMain:=TformMain.Create(Application)
    else
        formMain:=TformMain.Create(nil);

    try
        //Kompletter Text
        formMain.memoComplete.Lines.Text:=StrPas(Text);

        if (Sellength=0) then
            formMain.labelSel.Caption:='Der Cursor im Editor war auf Position '+IntToStr(SelStart)
        else
            formMain.labelSel.Caption:='Die Markierung im Editor ging von '+IntToStr(SelStart)+' bis '+IntToStr(SelStart+SelLength);

        formMain.memoComplete.SelStart:=SelStart;
        formMain.memoComplete.SelLength:=SelLength;

        //Markierter Text
        formMain.memoSelection.Lines.Text:=Copy(StrPas(Text), SelStart+1, SelLength);

        //Wichtig! Form nur Modal starten!
        formMain.ShowModal;

        Result:=StrNew(PChar(callBackText));

        formMain.Free;
    except
        //Falls ein unerwarteter Fehler auftritt
        callBackTyp:=cbCancel;

        Result:='';

        formMain.Free;
    end;
end;

//Das Plugin kann entweder den gesamten oder nur den markierten Text
//im Editor ersetzen.
//Diese Funktion wird aufgerufen, NACHDEM die Funktion StartPlugin
//aufgerufen wurde, also nach der Beendung des Plugins.
//Dies ermglicht die dynamische nderung des Rckgabetyps whrend das
//Plugin luft, er muss also nicht vorher festgelegt sein.

//Es knnen folgende Werte als Rckgabetyp bergeben werden:

//cbCancel      =       0       Bedeutet, das die Aktionen des Plugins abgebrochen wurden und nichts im Editor gendert wird.
//cbSelection   =       1       Bedeutet, das nur der markierte Text im Editor ersetzt werden soll.
//cbComplete    =       2       Bedeutet, das der komplette Text im Editor ersetzt werden soll.

function pluginRueckgabetyp: Integer; export; stdcall;
begin
    //callBackTyp ist die in form.pas deklarierte Variable
    Result:=callBackTyp;
end;

//Diese Funktion ist aus Kompatibilittsgrnden notwendig

function pluginInterfaceVersion: Integer; export; stdcall;
begin
    Result:=cbVersion;
end;

//Diese Funktion funktioniert nur, wenn das Plugin mit dem Scriptly
//zusammen verwendet wird.
//Sie dient dazu, das Formular korrekt anzusprechen und einzuordnen

function pluginSetHandle(AHandle: Integer): Integer; export; stdcall;
begin
    Application.Handle:=AHandle;
    if (Application<>nil)and(Application.Handle>0) then
        Result:=1
    else
        Result:=0;
end;

//Exportieren der Funktionen aus der DLL
exports
    pluginRueckgabetyp,
    pluginStart,
    pluginInterfaceVersion,
    pluginSetHandle;

end.

 